'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.default = MountedComponent;

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

var _dashify = require('dashify');

var _dashify2 = _interopRequireDefault(_dashify);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function MountedComponent() {}

Object.defineProperty(MountedComponent.prototype, 'length', {
  get: function get() {
    return this._el.length;
  },

  enumerable: true
});

/**
 * Initialise a new component with a vm and elements. Used internally by the
 * `mount()` function.
 *
 * @param {Object} TestComponent A Vue component to mount.
 * @param {Object} [props] An optional objects containing properties to pass.
 * @param {string} [slot] Optional slot content as a string.
 * @private
 */
MountedComponent.prototype._init = function initMountedComponent(TestComponent) {
  var props = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
  var slot = arguments.length <= 2 || arguments[2] === undefined ? '' : arguments[2];

  // If propsString makes you say wtf, please +1 the following issue:
  // https://github.com/vuejs/vue/issues/2114
  var propsString = (0, _keys2.default)(props).map(function (prop) {
    return ':' + (0, _dashify2.default)(prop) + '="' + prop + '"';
  }).join(' ');

  this._vm = new _vue2.default({
    template: '<div><test-component ' + propsString + '>' + slot + '</test-component></div>',
    components: { TestComponent: TestComponent },
    data: props
  }).$mount();

  this._el = this._vm.$el.children;
};

/**
 * Generate a new MountedComponent in the same VM, but with different elements.
 *
 * @param {Array|HTMLElement} el HTML element (or array of)
 * @returns {MountedComponent} New MountedComponent.
 * @private
 */
MountedComponent.prototype._newFromThis = function newFromThis(el) {
  var elMount = new MountedComponent();
  elMount._vm = this._vm;
  elMount._el = Array.isArray(el) ? el : [el];

  return elMount;
};

(0, _assign2.default)(MountedComponent.prototype, require('./mounted-fns/attributes'));
(0, _assign2.default)(MountedComponent.prototype, require('./mounted-fns/events'));
(0, _assign2.default)(MountedComponent.prototype, require('./mounted-fns/iteration'));
(0, _assign2.default)(MountedComponent.prototype, require('./mounted-fns/subsets'));
(0, _assign2.default)(MountedComponent.prototype, require('./mounted-fns/testing'));
(0, _assign2.default)(MountedComponent.prototype, require('./mounted-fns/traversal'));