'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.plugins = undefined;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.default = chaiPlugin;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Shortcut to add all plugins.
 */
function chaiPlugin(chai) {
  (0, _keys2.default)(plugins).forEach(function (plugin) {
    chai.use(plugins[plugin]);
  });
}

var plugins = exports.plugins = {
  attribute: require('./plugin-fns/attribute').default,
  className: require('./plugin-fns/className').default,
  empty: require('./plugin-fns/empty').default,
  fragment: require('./plugin-fns/fragment').default,
  match: require('./plugin-fns/match').default,
  selector: require('./plugin-fns/selector').default,
  tag: require('./plugin-fns/tag').default,
  text: require('./plugin-fns/text').default,
  value: require('./plugin-fns/value').default
};