'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.chaiPlugin = undefined;
exports.mount = mount;
exports.createMounter = createMounter;

var _chaiPlugin = require('./chai-plugin');

Object.defineProperty(exports, 'chaiPlugin', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_chaiPlugin).default;
  }
});

var _MountedComponent = require('./MountedComponent');

var _MountedComponent2 = _interopRequireDefault(_MountedComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Mount a given component with optional props, returning a MountedComponent
 * object with methods like `.text()` and `.find()`.
 *
 * @param {Object} TestComponent A Vue component to mount.
 * @param {Object} [props] An optional objects containing properties to pass.
 * @param {string} [slot] Optional slot content as a string.
 * @returns {MountedComponent}
 */
function mount(TestComponent, props, slot) {
  var mounted = new _MountedComponent2.default();
  mounted._init(TestComponent, props, slot);
  return mounted;
}

/**
 * Returns a function that creates new mounted instances of a components.
 *
 * @param {Object} TestComponent A Vue component to mount.
 * @returns {function([props], [slot]): MountedComponent} Function with
 * props and slot arguments.
 */
function createMounter(TestComponent) {
  return function (props, slot) {
    return mount(TestComponent, props, slot);
  };
}

// Passthrough