"use strict";

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Trigger event on the mounted elements.
 *
 * @param {string|Event} event Name of event to fire, or event object.
 */
exports.trigger = function triggerEvent(event) {
  (0, _from2.default)(this._el).forEach(function (el) {
    if (!(event instanceof Event)) {
      event = new Event(event);
    }

    el.dispatchEvent(event);
  });
};