'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = attribute;

var _MountedComponent = require('../MountedComponent');

var _MountedComponent2 = _interopRequireDefault(_MountedComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function attribute(chai, utils) {
  var Assertion = chai.Assertion;

  Assertion.addChainableMethod('attribute', function (attribute) {
    var obj = this._obj;

    new Assertion(obj).to.be.instanceof(_MountedComponent2.default);
    new Assertion(attribute).to.be.ok;

    utils.flag(this, 'vue.attribute', attribute);

    this.assert(obj.matches('[' + attribute + ']'), 'expected Vue component to have attribute #{exp}', 'expected Vue component to not have attribute #{exp}', attribute);
  });

  Assertion.addMethod('equals', function (expected) {
    var obj = this._obj;

    new Assertion(obj).to.be.instanceof(_MountedComponent2.default);
    var attribute = utils.flag(this, 'vue.attribute');
    new Assertion(attribute).to.be.ok;

    this.assert(obj.attr(attribute) === expected, 'expected attribute ' + attribute + ' to equal #{exp}, got #{act}', 'expected attribute ' + attribute + ' to not equal #{exp}', attribute, obj.attr(attribute));
  });
}