'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = className;

var _MountedComponent = require('../MountedComponent');

var _MountedComponent2 = _interopRequireDefault(_MountedComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function className(chai, utils) {
  var Assertion = chai.Assertion;

  Assertion.addMethod('className', function (className) {
    var obj = this._obj;

    new Assertion(className).to.not.contain(' ', 'invalid classname');
    new Assertion(obj).to.be.instanceof(_MountedComponent2.default);

    var containsFlag = utils.flag(this, 'contains');

    if (containsFlag) {
      this.assert(obj.find('.' + className), 'expected Vue component to contain element with className #{exp}', 'expected Vue component to not contain element with className #{exp}', className);
    } else {
      this.assert(obj.hasClass(className), 'expected Vue component to have className #{exp} (#{act})', 'expected Vue component to not have className #{exp}', className, obj.attr('class'));
    }
  });
}