'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = selector;

var _MountedComponent = require('../MountedComponent');

var _MountedComponent2 = _interopRequireDefault(_MountedComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function selector(chai, utils) {
  var Assertion = chai.Assertion;

  Assertion.addMethod('selector', function (selector) {
    var obj = this._obj;

    new Assertion(obj).to.be.instanceof(_MountedComponent2.default);
    new Assertion(selector).to.be.ok;

    if (utils.flag(this, 'vue.match')) {
      this.match(selector);
      return;
    }

    if (utils.flag(this, 'contains')) {
      this.assert(obj.contains(selector), 'expected Vue component to contain selector #{exp}', 'expected Vue component to not contain selector #{exp}', selector);
      return;
    }

    throw new Error('you need to specify either contains or matches');
  });
}